#ifndef PROCESSINGWIDGET_H
#define PROCESSINGWIDGET_H

#include <QWidget>

//! Basisklasse für alle Tabs des Hauptprogramms
class ProcessingWidget :public QWidget{
	public:
		//! Konstruktor
		ProcessingWidget(QWidget *parent=0):QWidget(parent){}
		/*! Wird ausgeführt, sobald der Tab aktiviert wird.
		 * Der Tab wird nur aktiviert, wenn activate() true zurückgibt und zuvor
		 * deactivate() des vorherigen Tabs true zurückgegeben hat.
		 * \see deactivate()
		 */
		virtual bool activate(){return true;}
		/*! Wird ausgeführt, sobald der Tab deaktiviert wird.
		 * Der neue Tab wird nur aktiviert, wenn activate() desselben true zurückgibt und zuvor
		 * deactivate() true zurückgibt.
		 * \attention Sollte der alte Tab reaktiviert werden (weil deactivate oder activate fehlgeschlagen
		 * ist), so wird activate NICHT erneut aufgerufen!
		 * \see activate()
		 */
		virtual bool deactivate(){return true;}
		//! Gibt den Informationstext zurück, der im Infobereich des Hauptfensters angezeigt wird.
		virtual QString information(){return QString();}
};

#endif // PROCESSINGWIDGET_H
