#include "hauptwidget.h"
//TODO: Check imagemagick, catch arbeitsdaten-exception
HauptWidget::HauptWidget(QWidget *parent)
	: QMainWindow(parent),next(trUtf8("Weiter"))
{
	setWindowTitle("Foto-Konverter");

	seiten[START]=new startseite();
	seiten[STARTPOSITION]=new startposition();
	seiten[HELL]=new hell();
	seiten[DUNKEL]=new dunkel();
	seiten[VORAUSWAHL]=new vorauswahl();

	vlayout.setOrientation(Qt::Vertical);
	vlayout.addWidget(&tabs);
	vlayout.addWidget(&hlayout);
	vlayout.setStretchFactor(0,1);
	hlayout.addWidget(&messageWindow);
	hlayout.addWidget(&information);
	hlayout.setCollapsible(1,false);
	vlayout.setChildrenCollapsible(false);
	setCentralWidget(&vlayout);

	enableExpert(false);

	progress.setMinimum(0);
	progress.setMaximum(100);
	statusBar()->addWidget(&progress,1);
	statusBar()->addPermanentWidget(&next);


	connect((startseite*)seiten[START],SIGNAL(enableExpert(bool)),SLOT(enableExpert(bool)));
	connect(&next,SIGNAL(clicked()),SLOT(snext()));
	connect(&tabs,SIGNAL(currentChanged(int)),SLOT(indexChanged(int)));
	connect(Messaging::getObject(),SIGNAL(addMessage(QString,QIcon)),SLOT(addMsg(QString,QIcon)),
			Qt::DirectConnection);
	connect(Messaging::getObject(),SIGNAL(progress(double)),SLOT(setProgress(double)));
	Messaging::message(trUtf8("Willkommen!"));
	setMinimumSize(400,400);
	information.setText(seiten[START]->information());
	information.setAlignment(Qt::AlignTop);
	information.setWordWrap(true);
	seiten[START]->activate();

}

void HauptWidget::addMsg(QString msg, QIcon icon){
	QListWidgetItem *item=new QListWidgetItem();
	item->setIcon(icon);
	item->setText(QTime::currentTime().toString("hh:mm:ss")+" - "+msg);
	messageWindow.addItem(item);
	messageWindow.scrollToBottom();
}

void HauptWidget::snext(){
	tabs.setCurrentIndex(tabs.currentIndex()+1);
}

void HauptWidget::setProgress(double p){
	progress.setValue(p>1?100:p<0?0:p*100);
}

void HauptWidget::indexChanged(int idx){
	static int oldIdx=0;
	if(oldIdx==idx||idx<0||tabs.count()==0)return;
	if(idx!=0 && !Workdata::isInitalized()){
			tabs.setCurrentIndex(0);
			oldIdx=0;
			((ProcessingWidget)tabs.currentWidget()).activate();
			return;
	}

	if(oldIdx==0 && idx!=1){
		seiten[START]->deactivate();
		seiten[VORAUSWAHL]->activate();
		seiten[VORAUSWAHL]->deactivate();
	}
	if(!((ProcessingWidget*)tabs.widget(oldIdx))->deactivate() ||
	   !((ProcessingWidget*)tabs.currentWidget())->activate()){
		tabs.setCurrentIndex(oldIdx);
		return;
	}
	information.setText(((ProcessingWidget*)tabs.currentWidget())->information());
	oldIdx=idx;
}


void HauptWidget::enableExpert(bool enable){
	tabs.clear();
	tabs.addTab(seiten[START],trUtf8("Allgemeines"));
	if(enable){
		tabs.addTab(seiten[VORAUSWAHL],"Vorauswahl");
		tabs.addTab(seiten[DUNKEL],trUtf8("Überflutet"));
		tabs.addTab(seiten[HELL],trUtf8("Trocken"));
	}
	tabs.addTab(seiten[STARTPOSITION],trUtf8("Fertigstellen"));
}

HauptWidget::~HauptWidget()
{

}

