#ifndef WIDGET_H
#define WIDGET_H

#include <QProcess>
#include <QtGui>
#include "startseite.h"
#include "startposition.h"
#include "hell.h"
#include "dunkel.h"
#include "vorauswahl.h"
#include "workdata.h"
#include "IProgress.h"
#include "ProcessingWidget.h"
#include "messaging.h"
/*! Hauptfenster des Programms.
 * Enthält die einzelnen Tabs und Informationswidgets
 */
class HauptWidget : public QMainWindow,IProgress
{
		Q_OBJECT

	public:
		//! Konstruktor
		HauptWidget(QWidget *parent = 0);
		//! Destruktor
		~HauptWidget();

	public slots:
		//! (De-)Aktiviert die erweiterten Einstellungen
		void enableExpert(bool enable);
		//! Setzt den Fortschritt der aktuellen Operation. Wird über Messaging gesteuert.
		void setProgress(double p);
		//! \brief Fügt dem Nachrichtenfenster einen neue Nachricht hinzu
		//! \see Messaging
		void addMsg(QString msg, QIcon icon);

	private slots:
		void snext();
		void indexChanged(int idx);


	signals:
	private:
		enum seite{START, STARTPOSITION=4};
		enum expert{VORAUSWAHL=1, DUNKEL=2, HELL=3};
		ProcessingWidget *seiten[5];

		QSplitter vlayout;
		QSplitter hlayout;
		QTabWidget tabs;
		QProgressBar progress;
		QPushButton next;
		QListWidget	messageWindow;
		QLabel information;

};

#endif // WIDGET_H
