#include "helldunkel.h"

helldunkel::helldunkel(QWidget *parent) :
	ProcessingWidget(parent)
{
	layout.addWidget(&loriginal,0,0);
	layout.addWidget(&lneu,0,1);
	layout.addWidget(&helligkeit,1,0,1,2);
	helligkeit.setOrientation(Qt::Horizontal);
	helligkeit.setMinimum(-100);
	helligkeit.setMaximum(100);
	setLayout(&layout);
	loriginal.setScaledContents(true);
	lneu.setScaledContents(true);

	stempfile=Workdata::getTempFileName()+".png";

	connect(&helligkeit,SIGNAL(valueChanged(int)),SLOT(sliderChanged(int)));
}

bool helldunkel::activate(){
	ioriginal.load("");
	QPixmapCache::clear();
	ioriginal.load(Workdata::getInstance().getFilename("original"));
	loriginal.setPixmap(ioriginal);
	return true;
}

helldunkel::~helldunkel(){
	QFile::remove(stempfile);
}
