#ifndef HELLDUNKEL_H
#define HELLDUNKEL_H

#include "ProcessingWidget.h"
#include "settings.h"
#include "workdata.h"
#include <QtGui>
#if QT_VERSION >= 0x050000
#include <QtWidgets>
#endif

/*! Basisklasse der Widgets hell und dunkel.
 * Layout und temporäre Datei werden erstellt, das abgeleitete Widget sollte information() und
 * sliderChanged(int) überschreiben. Bei Bedarf kann activate und deactivate überschrieben werden,
 * wobei darauf geachtet werden sollte, dass activate der Basisklasse aufgerufen wird.
 */
class helldunkel : public ProcessingWidget
{
		Q_OBJECT
	public:
		//! Konstruktor
		explicit helldunkel(QWidget *parent = 0);
		virtual bool activate();
		//! Destruktor
		virtual ~helldunkel();

	signals:

	public slots:
		//! Slot zur Verarbeitung der Sliderdaten
		virtual void sliderChanged(int value)=0;

	protected:
		//! Layout
		QGridLayout layout;
		//! \brief Widget zur Anzeige des Originalbilds
		//! \see ioriginal
		QLabel loriginal;
		//! \brief Widget zur Anzeige der Vorschau
		//! \see itemp
		QLabel lneu;
		//! Slider zur Helligkeitseinstellung
		QSlider helligkeit;
		//! \brief Originalbild
		//! \see loriginal
		QPixmap ioriginal;
		//! \brief Vorschaubild
		//! \see lneu
		QPixmap itemp;
		//! Datei für das Vorschaubild
		QString stempfile;
};

#endif // HELLDUNKEL_H
