#include "settings.h"

Settings::Settings(QObject *parent,QString present) :
	QSettings(QSettings::IniFormat,QSettings::UserScope,"fotokonverter","current",parent),
	present(present)
{
}

Settings &Settings::getInstance(){
	if(instance==NULL)
		loadSettings();
	return *instance;
}

bool Settings::copySettings(QString existing, QString neu){
	QSettings sets(QSettings::IniFormat,QSettings::UserScope,"fotokonverter",existing);
	QSettings sets2(QSettings::IniFormat,QSettings::UserScope,"fotokonverter",neu);
	if(!QFile::exists(sets.fileName())) return false;
	QFile::remove(sets2.fileName());
	QFile::copy(sets.fileName(),sets2.fileName());
	return true;
}

Settings* Settings::instance=NULL;

QString Settings::getConvert(){
	return value("paths/imagemagick/convert").toString();
}

QStringList Settings::getPresents(){
	QSettings sets(QSettings::IniFormat,QSettings::UserScope,"fotokonverter","default");
	if(!QFile::exists(sets.fileName())){
		sets.setValue("foo","bar");//create directories
		sets.sync();
		QFile::remove(sets.fileName());
		QFile::copy(":/settings/present1.ini",sets.fileName());
		QFile(sets.fileName()).setPermissions( QFile(sets.fileName()).permissions() | QFile::WriteOwner | QFile::WriteUser | QFile::WriteGroup | QFile::WriteOther );
		copySettings("default","Vorherige");
	}
	QDir set=QFileInfo(sets.fileName()).absoluteDir();
	QStringList files=set.entryList(QDir::Files);
	QStringList presents;
	foreach(QString str, files){
		if(QFileInfo(str).suffix()=="ini" && QFileInfo(str).baseName()!="current")
			presents.append(QFileInfo(str).baseName());
	}
	return presents;
}

QString Settings::getMogrify(){
	return value("paths/imagemagick/mogrify").toString();
}

QString Settings::getComposite(){
	return value("paths/imagemagick/composite").toString();
}

void Settings::setMogrify(QString path){
	if(!path.startsWith("\""))path="\""+path+"\"";
	setValue("paths/imagemagick/mogrify",path);
}

void Settings::setComposite(QString path){
	if(!path.startsWith("\""))path="\""+path+"\"";
	setValue("paths/imagemagick/composite",path);
}

void Settings::setConvert(QString path){
	if(!path.startsWith("\""))path="\""+path+"\"";
	setValue("paths/imagemagick/convert",path);
	if(status()!=NoError)qDebug(fileName().toLocal8Bit());
}

void Settings::loadSettings(QString present){
	if(instance)instance->sync();
	delete instance;
	if(!getPresents().contains(present))
		loadSettings();
	else{
		if(present!="current"){
			copySettings(present,"current");
		}
		instance=new Settings(0,present);
	}
}

void Settings::savePresent(QString present){
	instance->sync();
	copySettings("current",present);
}

