#ifndef STARTPOSITION_H
#define STARTPOSITION_H

#include <QtGui>
#if QT_VERSION >= 0x050000
#include <QtWidgets>
#endif
#include "ProcessingWidget.h"
#include "Grid/grid.h"
#include "settings.h"
#include "workdata.h"
#include "messaging.h"

int png2field(char* infile, char* outfile);

//! Zeigt die fertige Karte an und setzt die Startposition
class startposition : public ProcessingWidget
{
		Q_OBJECT
	public:
		//! Konstruktor
		explicit startposition(QWidget *parent = 0);
		virtual bool activate();
		//! Destruktor
		virtual ~startposition();
		virtual QString information();

	signals:

	public slots:
		//! Slot zur Behandlung des Klick-Events auf dem Grid
		void startPositionSelected(QPoint cell, Qt::MouseButton);
		//! Slot zur behandlung eines Klicks auf den Speichern-Button
		void save();
		//! Slot zur behandlung eines Klicks auf den Einstellungen-Speichern-Button
		void savePresent();
	private:
		QGridLayout layout;
		Grid grid;
		//Temporäre Dateien
		QString shell, sdunkel, smedium, soriginal,smask1,smask2,smap;
		QPoint startPosition;
		char startPositionState;
		QPushButton bsave;
		QPushButton bsavePresent;
};

#endif // STARTPOSITION_H
