#ifndef STARTSEITE_H
#define STARTSEITE_H

#include <QtGui>
#if QT_VERSION >= 0x050000
	#include <QtWidgets>
#endif
#include "ProcessingWidget.h"
#include "settings.h"
#include "workdata.h"
//! Startseite mit den allgemeinen Optionen.
class startseite : public ProcessingWidget
{
		Q_OBJECT
	public:
		//! Konstruktor
		explicit startseite(QWidget *parent = 0);
		virtual QString information();
		virtual bool activate();

	signals:
		//! Das Signal zeigt die Auswahl der erweiterten Einstellungen
		void enableExpert(bool enable);

	public slots:
		//! Slot für die erweiterte-Einstellungen-Checkbox
		void checkExpert(bool checked);
		//! Slot für den ...-Button des Bilds
		void selectFile();
		//! Slot für den ...-Button für Convert
		void selectConvert();
		//! Slot für den ...-Button für Mogrify
		void selectMogrify();
		//! Slot für den ...-Button für Composite
		void selectComposite();
		//! Wird bei Änderungen der Bild-Inputbox aufgerufen
		void loadFile();
		//! Wird bei Änderungen der Bild-Breite aufgerufen
		void widthChanged();
		//! Wird bei Änderungen der Bild-Höhe aufgerufen
		void heightChanged();
		//! Wird bei Änderungen der Mogrify-Inputbox aufgerufen
		void mogrifyChanged();
		//! Wird bei Änderungen der Convert-Inputbox aufgerufen
		void convertChanged();
		//! Wird bei Änderungen der Composite-Inputbox aufgerufen
		void compositeChanged();
		//! Wird bei Auswahl eines anderen Presents aufgerufen
		void presentChanged(QString newPresent);

	private:
		QGridLayout layout;
		QCheckBox expertMode;
		QLabel lfilename,lsize,lsize2,lmogrify,lconvert,lcomposite,lpresent;
		QLineEdit ewidth,eheight,emogrify,econvert,efilename,ecomposite;
		QPushButton bfilename,bmogrify,bconvert,bcomposite;
		QComboBox cpresent;
		bool activating;

};

#endif // STARTSEITE_H
