#include "vorauswahl.h"

//TODO: settings
vorauswahl::vorauswahl(QWidget *parent) :
	ProcessingWidget(parent)
{
	for(int i=0;i<4;i++){
		layout.addWidget(&labels[i],1,i);
		layout.addWidget(&radios[i],2,i);
		files[i]=Workdata::getTempFileName()+".png";
		labels[i].setScaledContents(true);
	}

	setLayout(&layout);

}

bool vorauswahl::activate(){
	radios[Settings::getInstance().value("vorauswahl",0).toInt()].setChecked(true);

	Messaging::message(trUtf8("Bilder für Vorauswahl werden erzeugt"));
	Messaging::setProgress(0);
	if(!Workdata::convert("-colorspace Gray",Workdata::getInstance().getFilename("original"),files[0]))
		return false;
	Messaging::setProgress(0.3);

	if(!Workdata::convert("-channel R -separate",Workdata::getInstance().getFilename("original"),files[1]))
		return false;

	Messaging::setProgress(0.6);

	if(!Workdata::convert("-channel B -separate",Workdata::getInstance().getFilename("original"),files[2]))
		return false;

	Messaging::setProgress(0.9);

	if(!Workdata::convert("-channel G -separate",Workdata::getInstance().getFilename("original"),files[3]))
		return false;

	Messaging::setProgress(1);
	Messaging::message(trUtf8("Bilder für Vorauswahl erzeugt"));

	for(int i=0;i<4;i++){
		pixmaps[i].load("");
		QPixmapCache::clear();
		pixmaps[i].load(files[i]);
		labels[i].setPixmap(pixmaps[i]);
	}
	return true;
}

bool vorauswahl::deactivate(){
	for(int i=0;i<4;i++){
		if(radios[i].isChecked()){
			Workdata::getInstance().setFilename("vorauswahl",files[i]);
			Settings::getInstance().setValue("vorauswahl",i);
		}else{
			QFile::remove(files[i]);
		}
	}
	return true;
}

QString vorauswahl::information(){
	return trUtf8("Bitte das Bild auswählen, auf dem das Original am besten erkennbar ist, und bei \
dem der Kontrast am höchsten ist.");
}
