/*! \file png2field.cpp
 * \author F.Satzger
 * Enthält die Umwandlungsfunktion, die pngs in Bilder umwandelt.
 */

#include <QString>
#include <QImage>
#include <fstream>

using namespace std;
/*! Konvertiert eine png-Datei in ein ASCII-Bild
 * Dabei werden die Farben
 * - \#000000 zu .
 * - \#808080 zu o
 * - \#FFFFFF zu #
 */
int png2field(char* infile, char* outfile)
{
	QImage img;
	if(!img.load(infile)){
		return 1;
	}

	ofstream out(outfile,ios_base::binary|ios_base::out);
	if(!out.is_open()){
		return 2;
	}
	out<<"GAMEBOARDSTART "<<img.width()<<","<<img.height()<<"\n";

	for(int y=0;y<img.height();y++){
		for(int x=0;x<img.width();x++){
			switch (qGray(img.pixel(x,y))){
				case 0:
					out<<".";
					break;
				case 255:
					out<<"#";
					break;
				case 128:
					out<<"o";
					break;
				default:
					return 3;
			}
		}
		out<<"\n";
	}
	out<<"GAMEBOARDEND\n";
	out.close();
	return 0;
}
